clc
clear all
alp=0.1;
data=xlsread('data_in.xlsx'); % You need to upload the your data here. The first sever columns are input features and the last column is the response variable (here SR)
rng(1) %seed for reproducibility
rand_pos = (randperm(length(data)));
for k = 1:length(data)
    data(k) = data(rand_pos(k));
end
nComp=5;
[coeff,score,latent,~,explained] = pca(data(:,1:end-1));
Pca_data = score(:,1:nComp)*coeff(:,1:nComp)';
data=[Pca_data data(:,end)];
%data=rmoutliers(data,'mean');
C = .5; 
lambda =1.4; 
epsilon = .1;
kerneloption = 1;
kernel='polyhomog';%kernel='poly';%kernel='gaussian';%kernel='gaussianslow';%kernel='multiquadric';%kernel='jcb';%kernel='tensorwavkernel';
verbose=4;
b=45;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   NOT STANDARISED
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t_NS=tic;
x_train=data(1:b,1:end-1);%x=trn;
%x_train=zscore(x_train);
%x=x-mean(x);
y_train=data(1:b,end);
xtest=data(b+1:end,1:end-1);%xtest=tin;
%xtest=zscore(xtest);
%xtest=xtest-mean(xtest);
ytest=data(b+1:end,end);
[ypred,r,mse,rmse,SSE,NS_para1,NS_para2,NS_para3]=SVMfunction(x_train,y_train,xtest,ytest,b,C,lambda,epsilon,kernel,kerneloption,verbose);
R_NOTSTD=r;
mse_NOTSTD=mse;
rmse_NOTSTD=rmse;
SSE_NOTSTD=SSE;
n = length(y_train); % Number of training cases
p = 2; % Number of parameters (weights and biases)
% Schwarz's Bayesian criterion (or BIC) (Schwarz, 1978)
NOTSTD_BIC = n * log(SSE_NOTSTD/n) + p * log(n);
% Akaike's information criterion (Akaike, 1969)
NOTSTD_AIC = n * log(SSE_NOTSTD/n) + 2 * p;
% Corrected AIC (Hurvich and Tsai, 1989)
NOTSTD_AICc = n * log(SSE_NOTSTD/n) + (n + p) / (1 - (p + 2) / n);
p1 = plot(ytest,ypred,'sr','MarkerSize',8,'linewidth',0.8);
%p1.Color(4) = 0.5;
%alpha(p1,alp)
hold on
t_NS_total=toc(t_NS);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Center Mean
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t_CM=tic;
x_train=data(1:b,1:end-1);%x=trn;
%x_train=zscore(x_train);
%x_train=x_train-mean(x_train);
x_train=normalize(x_train,'center','mean');
y_train=data(1:b,end);
xtest=data(b+1:end,1:end-1);%xtest=tin;
%xtest=zscore(xtest);
%xtest=xtest-mean(xtest);
xtest=normalize(xtest,'center','mean');
ytest=data(b+1:end,end);
[ypred,r,mse,rmse,SSE,C_para1,C_para2,C_para3]=SVMfunction(x_train,y_train,xtest,ytest,b,C,lambda,epsilon,kernel,kerneloption,verbose)
R_mean_center=r;
mse_mean_center=mse;
rmse_mean_center=rmse;
SSE_mean_center=SSE;
Mean_center_BIC = n * log(SSE_mean_center/n) + p * log(n);
% Akaike's information criterion (Akaike, 1969)
Mean_center_AIC = n * log(SSE_mean_center/n) + 2 * p;
% Corrected AIC (Hurvich and Tsai, 1989)
Mean_center_AICc = n * log(SSE_mean_center/n) + (n + p) / (1 - (p + 2) / n);
hold on
%p2=plot(ytest,ypred,'^k','linewidth',1,'MarkerFaceColor', 'k');
p2=plot(ytest,ypred,'^b','MarkerSize',8,'linewidth',0.8);
%p2.Color(4) = 0.5;
%alpha(p2,alp)
hold on
t_CM_total=toc(t_CM);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Center Median
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%x_train=data(1:b,2:end-1);%x=trn;
%x_train=zscore(x_train);
%x_train=x_train-mean(x_train);
%x_train=normalize(x_train,'center','median');
%y_train=data(1:b,end);
%xtest=data(b+1:end,2:end-1);%xtest=tin;
%xtest=zscore(xtest);
%xtest=xtest-mean(xtest);
%xtest=normalize(xtest,'center','median');
%ytest=data(b+1:end,end);
%[ypred,r,mse,rmse]=SVMfunction(x_train,y_train,xtest,ytest,b,C,lambda,epsilon,kernel,kerneloption,verbose);
%R_median_center=r;
%mse_median_center=mse;
%rmse_median_center=rmse;
%hold on
%p2=plot(ytest,ypred,'^k','linewidth',1,'MarkerFaceColor', 'k');
%p2=plot(ytest,ypred,'vk', 'MarkerSize',4);
%p2.Color(4) = 0.5;
%hold on
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% zscore
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t_ZM=tic;
x_train=data(1:b,1:end-1);%x=trn;
x_train=zscore(x_train);
%x=x-mean(x);
y_train=data(1:b,end);
xtest=data(b+1:end,1:end-1);%xtest=tin;
xtest=zscore(xtest);
%xtest=xtest-mean(xtest);
ytest=data(b+1:end,end);
[ypred,r,mse,rmse,SSE,ZS_para1,ZS_para2,ZS_para3]=SVMfunction(x_train,y_train,xtest,ytest,b,C,lambda,epsilon,kernel,kerneloption,verbose);
R_zscore=r;
mse_zscore=mse;
rmse_zscore=rmse;
SSE_zscore=SSE;
Zscore_BIC = n * log(SSE_zscore/n) + p * log(n);
% Akaike's information criterion (Akaike, 1969)
Zscore_AIC = n * log(SSE_zscore/n) + 2 * p;
% Corrected AIC (Hurvich and Tsai, 1989)
Zscore_AICc = n * log(SSE_zscore/n) + (n + p) / (1 - (p + 2) / n);
p3=plot(ytest,ypred,'og','MarkerSize',8,'linewidth',0.8);
%p3.Color(4) = 0.2;
%alpha(p3,alp)
hold on
t_ZM_total=toc(t_ZM);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5%%
% Range
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%x_train=data(1:b,2:end-1);%x=trn;
%x_m_train=mean(x_train);
%min_x_train=min(x_train);
%max_x_train=max(x_train);
%diff=max_x_train-min_x_train;
%x_train=x_train-min_x_train;
%x_train=x_train./diff;
%x_train=zscore(x_train);
%y_train=data(1:b,end);
%xtest=data(b+1:end,2:end-1);%xtest=tin;
%min_xtest=min(xtest);
%max_xtest=max(xtest);
%diff=max_xtest-min_xtest;
%xtest=xtest-min_xtest;
%xtest=xtest./diff;
%xtest=zscore(xtest);
%xtest=xtest-(x_m_train);
%ytest=data(b+1:end,end);
t_MM=tic;
x_train=data(1:b,1:end-1);%x=trn;
x_train_MM=x_train;
x_train=normalize(x_train,'range');
y_train=data(1:b,end);
y_train_MM=y_train;
xtest=data(b+1:end,1:end-1);%xtest=tin;
xtest_MM=xtest;
xtest=normalize(xtest,'range');
%xtest=xtest-mean(xtest);
ytest=data(b+1:end,end);
ytest_MM=ytest;
[ypred,r,mse,rmse,SSE,para1,para2,para3]=SVMfunction(x_train,y_train,xtest,ytest,b,C,lambda,epsilon,kernel,kerneloption,verbose);
bias_mm=sum(ypred-ytest)/length(ypred);
ypred_MM=ypred;
R_range=r;
mse_range=mse;
rmse_range=rmse;
SSE_range=SSE;
Range_BIC = n * log(SSE_range/n) + p * log(n);
% Akaike's information criterion (Akaike, 1969)
Range_AIC = n * log(SSE_range/n) + 2 * p;
% Corrected AIC (Hurvich and Tsai, 1989)
Range_AICc = n * log(SSE_range/n) + (n + p) / (1 - (p + 2) / n);
hold on
%p2=plot(ytest,ypred,'^k','linewidth',1,'MarkerFaceColor', 'k');
p2=plot(ytest,ypred,'pk','MarkerSize',8,'linewidth',0.8);
%p2.Color(4) = 0.5;
%alpha(p2,alp)
hold on
t_MM_total=toc(t_MM);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Scale
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t_S=tic;
x_train=data(1:b,1:end-1);%x=trn;
x_train=normalize(x_train,'scale');
y_train=data(1:b,end);
xtest=data(b+1:end,1:end-1);%xtest=tin;
xtest=normalize(xtest,'scale');
%xtest=xtest-mean(xtest);
ytest=data(b+1:end,end);
[ypred,r,mse,rmse,SSE,S_para1,S_para2,S_para3]=SVMfunction(x_train,y_train,xtest,ytest,b,C,lambda,epsilon,kernel,kerneloption,verbose);
R_scale=r;
mse_scale=mse;
rmse_scale=rmse;
SSE_scale=SSE;
Scale_BIC = n * log(SSE_scale/n) + p * log(n);
% Akaike's information criterion (Akaike, 1969)
Scale_AIC = n * log(SSE_scale/n) + 2 * p;
% Corrected AIC (Hurvich and Tsai, 1989)
Scale_AICc = n * log(SSE_scale/n) + (n + p) / (1 - (p + 2) / n);
p3=plot(ytest,ypred,'dc','MarkerSize',8,'linewidth',0.8);
%p3.Color(4) = .1;
%alpha(p3,alp)
hold on
t_S_total=toc(t_S);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Norm
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%x_train=data(1:b,2:end-1);%x=trn;
%x_train=normalize(x_train,'norm',1);
%y_train=data(1:b,end);
%xtest=data(b+1:end,2:end-1);%xtest=tin;
%xtest=normalize(xtest,'norm',1);
%xtest=xtest-mean(xtest);
%ytest=data(b+1:end,end);
%[ypred,r,mse,rmse]=SVMfunction(x_train,y_train,xtest,ytest,b,C,lambda,epsilon,kernel,kerneloption,verbose);
%R_norm=r;
%p3=plot(ytest,ypred,'*k', 'MarkerSize',4);
%p3.Color(4) = 0.2;
%hold on
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Robust
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%x_train=data(1:b,2:end-1);%x=trn;
%x_train=normalize(x_train,'zscore','robust');
%y_train=data(1:b,end);
%xtest=data(b+1:end,2:end-1);%xtest=tin;
%xtest=normalize(xtest,'zscore','robust');
%xtest=xtest-mean(xtest);
%ytest=data(b+1:end,end);
%[ypred,r,mse,rmse]=SVMfunction(x_train,y_train,xtest,ytest,b,C,lambda,epsilon,kernel,kerneloption,verbose);
%R_rzscore=r;
%mse_rzscore=mse;
%rmse_rzscore=rmse;
%p3=plot(ytest,ypred,'.k');
%p3.Color(4) = 0.2;
%hold on
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5%%%%%%%%%%%%%%%
% Footer
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
x_st=0:0.5:5;
p7=plot(x_st,x_st,'--k','linewidth',1);
p7.Color(4)=0.3;
box on
%set(gcf, 'Position',  [100, 100, 650, 400])
axis([0 3.5 0 3.5]);
xlabel('In-situ Surface Roughness [cm]')
ylabel('Predicted Surface Roughness [cm]')
%legend('PCA-NS-SVR','PCA-CM-SVR','PCA-ZM-SVR','PCA-MM-SVR','PCA-S-SVR','Location','bestoutside','Orientation','horizontal')
%set(gcf,'Position',[100 100 700 675])
%pbaspect([1 1 1])